Name: fggl
Version: 0.1.0
Release: 1%{?dist}
Summary: FOSS Galaxy game library

License: LGPLv3

# The source was pulled from github
source0: https://git.fossgalaxy.com/gamedev/fggl/-/archive/develop/fggl-develop.zip

BuildRequires: g++
BuildRequires: cmake
BuildRequires: glfw-devel
BuildRequires: openal-devel
BuildRequires: glm-devel
BuildRequires: glfw-devel
BuildRequires: openal-soft-devel
BuildRequires: spdlog-devel
BuildRequires: freetype-devel
BuildRequires: yaml-cpp-devel
BuildRequires: assimp-devel
BuildRequires: bullet-devel
BuildRequires: gtest-devel
BuildRequires: gmock-devel

# demo desktop stuff
BuildRequires: libappstream-glib
BuildRequires: desktop-file-utils

%description
%{summary}.

%prep
%setup -q -n %{name}-develop

%build
%cmake
%cmake_build

%install
%cmake_install

%check
%ctest
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/*.metainfo.xml
desktop-file-validate %{buildroot}/%{_datadir}/applications/com.fossgalaxy.fggl.Demo.desktop

%package demos
Summary: Demos for fggl
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description demos
FGGL example binaries

%package devel
Summary: FGGL development libraries and header files
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
fggl dynamic libraries and header files.

%files
%{_libdir}/libfggl.so

%files devel
%{_includedir}/fggl/*
%{_libdir}/cmake/%{name}
# this feels like a packaging bug...
%{_libdir}/libimgui.a

%files demos
%{_bindir}/demo
%{_datadir}/fggl-demo/*
%{_datadir}/applications/com.fossgalaxy.fggl.Demo.desktop
%{_metainfodir}/com.fossgalaxy.fggl.Demo.metainfo.xml
