/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 27/06/22.
// see https://youtrack.jetbrains.com/issue/CPP-5059

#ifndef FGGL_DEBUG_PRAGMAS_HPP
#define FGGL_DEBUG_PRAGMAS_HPP

#if defined(__clang__)
#define PRAGMA_DIAGNOSTIC_PUSH _Pragma("clang diagnostic push")
#elif defined(__GNUC__)
#define PRAGMA_DIAGNOSTIC_PUSH _Pragma("gcc diagnostic push")
#else
#define PRAGMA_DIAGNOSTIC_PUSH
#endif

#if defined(__clang__)
#define PRAGMA_DIAGNOSTIC_POP _Pragma("clang diagnostic pop")
#elif defined(__GNUC__)
#define PRAGMA_DIAGNOSTIC_POP _Pragma("gcc diagnostic pop")
#else
#define PRAGMA_DIAGNOSTIC_POP
#endif

#if defined(__JETBRAINS_IDE__)
#define PRAGMA_CLION_IGNORED(x) _Pragma("ide diagnostic ignored \"" x "\"")
#else
#define PRAGMA_CLION_IGNORED
#endif

#endif //FGGL_DEBUG_PRAGMAS_HPP
