/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 31/07/22.
//

#ifndef FGGL_INTEGRATIONS_BULLET_PHYS_BULLET_MODULE_HPP
#define FGGL_INTEGRATIONS_BULLET_PHYS_BULLET_MODULE_HPP

#include "fggl/modules/module.hpp"
#include "fggl/entity/module.hpp"

#include "fggl/phys/types.hpp"
#include "fggl/phys/service.hpp"
#include "fggl/phys/bullet/types.hpp"

namespace fggl::phys::bullet {

	constexpr util::GUID CONFIG_PHYS_BODY = util::make_guid("phys::body");

	struct Bullet {
		constexpr static const char* name = "fggl::phys::bullet";
		constexpr static const std::array<modules::ModuleService, 1> provides = {
			phys::PhysicsProvider::service
		};
		constexpr static const std::array<modules::ModuleService, 1> depends = {
			entity::EntityFactory::service
		};
		static bool factory(modules::ModuleService name, modules::Services& serviceManager);
	};

} // namespace fggl::phys::bullet

namespace fggl::phys {
	using Bullet3 = bullet::Bullet;

} // namespace fggl::phys

#endif //FGGL_INTEGRATIONS_BULLET_PHYS_BULLET_MODULE_HPP
